<?php

/*

	FASDIM: Fast And Simple DeIdentification Method
	Copyright (C) 2013 Emmanuel Chazard http://emmanuel.chazard.org
	Check for updates on http://fasdim.org
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 3 of the License.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.


*/



print("
STEP 02
This program transforms your DOC files (doc_nonano) to unmodified TXT files (txt_nonano).
You can run several instances of this program in the same time. E.g. if your processor has 8 cores, you are encouraged to launch the programm 7 times to save some time.
In case too many files are (randomely) skipped, you can try again after having reinitialized the file queue, e.g.:
\t SELECT statut, count(*) FROM mytable_docnonano2txtnonano GROUP BY statut ;
\t UPDATE mytable_docnonano2txtnonano SET statut=0 WHERE statut=1 ;

") ;

$liste_param=array('doc_nonano', 'txt_nonano',
	'database_dsn', 'database_user', 'database_password',
	'wvware',
	'table_docnonano2txtnonano'
) ;


require_once('./scripts/fasdim_include.inc') ;


/* ======================= Parameters ============================= */


$dir_in = $configuration->get('doc_nonano') ;
$dir_out =  $configuration->get('txt_nonano') ;
$table_name = $configuration->get('table_docnonano2txtnonano') ;
$wvware_command = $configuration->get('wvware') ;


/*  =========== MAIN =========== */


print( $bdd->get_string_lock_status($table_name) );


$i=0 ;
print "\n\n\n$i files" ;


while( $file_name = $bdd->lock_file($table_name) ) {
	$filename_doc = $dir_in .'/'.$file_name ;
	$filename_txt = $dir_out .'/'.str_replace('.doc','.txt', $file_name) ;
	
	$command = $wvware_command .' '. $filename_doc .' > '. $filename_txt ;
	// print "\n$command\n" ;
	exec($command) ;

	$bdd->unlock_file($table_name, $file_name) ;
	$i++ ;
	print "\r$i files" ;
}



print( "\n\n". $bdd->get_string_lock_status($table_name) . "\n\n" );

?>

STEP 02 DONE
Please check the error log file if necessary.
