<?php


/*

	FASDIM: Fast And Simple DeIdentification Method
	Copyright (C) 2013 Emmanuel Chazard http://emmanuel.chazard.org
	Check for updates on http://fasdim.org
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, version 3 of the License.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.



*/

print("
STEP 05
This program extracts patterns from the prepared TXT files:
- tokens
- patterns involving numbers
Then, you will have to filter those patterns and define the allowed words and the number protection patterns.
Only one instance of the program must be run in the same time.
") ;

$liste_param=array('txt_preano',
	'database_dsn', 'database_user', 'database_password',
	'table_txtnonano2txtpreano',
	'tokens_to_filter', 'number_contexts_to_filter'
) ;


require_once('./scripts/fasdim_include.inc') ;


/* ======================= Parameters ============================= */

$file_out_words_dictionnary = $configuration->get('tokens_to_filter') ;
$file_out_numbers_dictionnary = $configuration->get('number_contexts_to_filter') ;  // those patterns, once filtered, still have to be defined in the source code of step 7
$dir_in =  $configuration->get('txt_preano') ;
$table_name = $configuration->get('table_txtnonano2txtpreano') ;


/* ======================= Functions ============================= */


// This function registers iteratively the list of words. This is useful in case the program stops during the execution...
function save_dictionnaries_to_disk() {
	GLOBAL $word_dictionnary, $file_out_words_dictionnary, $numbers_dictionnary, $file_out_numbers_dictionnary ;

	print "\tSaving the list of words.." ;
	arsort( $word_dictionnary ) ;
	$fp = fopen( $file_out_words_dictionnary, 'w' ) ;
	foreach( $word_dictionnary as $word => $nb ) {
		fwrite( $fp, "$word \t $nb\r\n" ) ;
	}
	fclose( $fp ) ;
	print ".OK\t" ;

	print "\tSaving the list of number contexts.." ;
	arsort( $numbers_dictionnary ) ;
	$fp = fopen( $file_out_numbers_dictionnary, 'w' ) ;
	foreach( $numbers_dictionnary as $number=>$eff) {
		fwrite( $fp, "$number\t$eff\r\n" ) ;
	}
	fclose( $fp ) ;
	print ".OK\t" ;
}

/*  =========== MAIN =========== */

print( $bdd->get_string_lock_status($table_name) );

$i=0 ;
print "\n\n\n$i records" ;


$word_dictionnary = array() ;
$numbers_dictionnary = array() ;

$file_list = $bdd->get_file_list($table_name, 2) ;

$nb = count( $file_list ) ;
print "\nThere are $nb files to analyze." ;
$barre = new batch_progression_bar(0, $nb ) ;
$barre->draw() ;
for( $i=0; $i<count($file_list) ; $i++) {
	$filename= $dir_in.'/'.$file_list[$i] ;
	$string = file_get_contents( $filename ) ;
	// we extract the different tokens
	$keywords = preg_split('/[\p{P}\p{S}\p{Z}\p{M}\\n\\r\s]+/', $string , -1, PREG_SPLIT_NO_EMPTY );  // punctuation mark, symbol, spacer, mark
	$tabcont = array_count_values( $keywords) ;
	foreach( $tabcont as $word=>$eff) {
		if( !preg_match( '|^\d+$|i', $word)) {
			if( isset( $word_dictionnary[$word] )) {
				$word_dictionnary[$word] += $eff ;
			} else {
				$word_dictionnary[$word] = $eff ;
			}
		}
	}
	// we extract the patterns containing numbers
	preg_match_all("|\b(\S+)\s*\d|iU", $string, $matches_left, PREG_PATTERN_ORDER);
	preg_match_all("|\d\s*(\S+)\b|iU", $string, $matches_right, PREG_PATTERN_ORDER);
	foreach($matches_left[1] as $a_word) {
		if( !preg_match( '|^\d+$|i', $a_word)) {
			$pattern = $a_word." ***" ;
			if( isset( $numbers_dictionnary[$pattern] )) {
				$numbers_dictionnary[$pattern] ++ ;
			} else {
				$numbers_dictionnary[$pattern] =1 ;
			}
		}
	}
	foreach($matches_right[1] as $a_word) {
		if( !preg_match( '|^\d+$|i', $a_word)) {
			$pattern = "*** ". $a_word ;
			if( isset( $numbers_dictionnary[$pattern] )) {
				$numbers_dictionnary[$pattern] ++ ;
			} else {
				$numbers_dictionnary[$pattern] =1 ;
			}
		}
	}
	$barre->forward($i) ;
	// from time to time...
	if( $i % 500==0 and $i>0 ) {
		save_dictionnaries_to_disk() ;
	}
}



print "\n\n\n" ;
save_dictionnaries_to_disk() ;
print "\n\n\n" ;

?>




STEP 05 DONE
Please check the error log file if necessary.
Now, you should exam the output files and filter the token and numbers, in order to prepare next step.

